{Program to test the unit mpcalc - v. 2.9}
PROGRAM mptest29;

USES mpcalc71,crt;

VAR

b,w,prec,prec_out,prec_spc,prec_ex: word;
t,u: char;
s,sb: ansistring;
fv,fm: boolean;
e1,e2,e3,e4,e5,e6,en,eb: extnum;
ex: extended;
p,p1,p2,p3,ek,eq: extnum;
a1,a2,a3,a4,a5: extnum;

{input a numeric ansistring of real type with a maximum of maxcar digits}
FUNCTION inpstnum (maxcar: word): ansistring;
BEGIN
b:=0; s:=''; fm:=false; fv:=false;
repeat
t:=readkey;
if t=#0 then t:=chr(ord(readkey)+128);
IF (t=#8) AND (b>0) then begin
if s[b]='.' then fv:=false;
if (s[b]='+') or (s[b]='-') then fm:=false;
write(#8' '#8);
delete(s,b,1);
dec(b);
If b=0 then fm:=false
end
else
if (b<maxcar)
and (((t='.') and (b>0) and (fv=false) and ((b<>1) OR (fm=false)))
or (((t>#48) and (t<#58)) and ((b<>1) or (s[1]<>'0'))
and ((b<>2) or (fm=false) or (s[2]<>'0')))
or ((b=0) and ((t='-') or (t='+')))
or ((t='0') and ((b<>1) or (s[1]<>'0')) and ((b<>2) or
(fm=false) or (s[2]<>'0'))))
then begin
if t='.' then fv:=true;
if (t='-') or (t='+') then fm:=true;
Inc(b);
s:=s+t;
write(t)
end;
until t=#13;
if s<>'' then begin
if s[1]='+' then delete(s,1,1);
if s='-0' then s:='0'
else if s='-' then s:=''
end;
inpstnum:=s;
writeln
END;

PROCEDURE red_2pi (ea: extnum; var ec: extnum);
BEGIN
if xlt(ea,p2) then xtox(ea,ec)
else begin
xdiv(ea,p2,eq);
xint(eq,eq);
xmul(eq,p2,eq);
xsub(ea,eq,ec)
end
END;

PROCEDURE red_pi (ea: extnum; var ec: extnum);
BEGIN
if xlt(ea,p) then xtox(ea,ec)
else begin
xdiv(ea,p,eq);
xint(eq,eq);
xmul(eq,p,eq);
xsub(ea,eq,ec)
end
END;

PROCEDURE sin_red (ev: extnum; var ez: extnum);
BEGIN
xtox(ev,ek);
ek.s:=1;
red_2pi(ek,ez);
if ev.s=0 then xsub(p2,ez,ez);
if xlte(ez,p1) then exit;
if xlte(ez,p3) then xsub(p,ez,ez) else xsub(ez,p2,ez)
END;

PROCEDURE cos_red (ev: extnum; var ez: extnum);
BEGIN
xtox(ev,ek);
ek.s:=1;
red_2pi(ek,ez);
if ev.s=0 then xsub(p2,ez,ez);
if xgt(ez,p) then xsub(p2,ez,ez)
END;

PROCEDURE tan_red (ev: extnum; var ez: extnum);
BEGIN
xtox(ev,ek);
ek.s:=1;
red_pi(ek,ez);
if ev.s=1 then begin
if xgte(ez,p1) then xsub(ez,p,ez)
end
else begin
if xlt(ez,p1) then ez.s:=0 else xsub(p,ez,ez)
end
END;

PROCEDURE cot_red (ev: extnum; var ez: extnum);
BEGIN
xtox(ev,ek);
ek.s:=1;
red_pi(ek,ez);
if ev.s=0 then xsub(p,ez,ez)
END;

PROCEDURE sec_red (ev: extnum; var ez: extnum);
BEGIN
xtox(ev,ek);
ek.s:=1;
red_2pi(ek,ez);
if xgte(ez,p) then xsub(p2,ez,ez)
END;

PROCEDURE csc_red (ev: extnum; var ez: extnum);
BEGIN
xtox(ev,ek);
ek.s:=1;
red_2pi(ek,ez);
if ev.s=1 then begin
if xlte(ez,p1) then exit;
if xlte(ez,p3) then xsub(p,ez,ez) else xsub(ez,p2,ez)
end
else begin
if xlte(ez,p1) then ez.s:=0
else if xlte(ez,p) then begin
xsub(p,ez,ez);
ez.s:=0
end
else if xlte(ez,p3) then xsub(ez,p,ez)
else xsub(p2,ez,ez)
end
END;

PROCEDURE getkey;
BEGIN
gotoxy(1,25);
write('press a key (Q to quit)... ');
t:=upcase(readkey)
END;

PROCEDURE spc_proc;
BEGIN
prec_ex:=usrdigits;
usrdigits:=prec_spc;
clrscr;
xabs(e1,eb);
xtostr(eb,sb);
if sb[1]='+' then delete(sb,1,1);
write('x=');
xdisplay(e1);
writeln;
xerf(e1,e2);
writeln('error function xerf(x)=');
xdisplay(e2);
writeln;
if (e2.c[1]=1) and (e2.n=1) then
writeln('asymptotic value, can''t calculate the inverse function')
else begin
xerfinv(e2,e4);
xapp(e4,e4,prec_out);
writeln('inverse xerfinv of the error function');
xdisplay(e4);
if xeq(e4,e1) then begin
writeln;
writeln('ok')
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
xerfc(e1,e2);
writeln('complementary error function xerfc(x)=');
xdisplay(e2);
writeln;
if ((e2.c[1]=0) or (e2.c[1]=2)) and (e2.n=1) then
writeln('asymptotic value, can''t calculate the inverse function')
else begin
xerfcinv(e2,e4);
xapp(e4,e4,prec_out);
writeln('inverse xerfcinv of the complementary error function');
xdisplay(e4);
if xeq(e4,e1) then begin
writeln;
writeln('ok')
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('|x|=');
write(sb);
gotoxy(1,3);
xphi(eb,e2);
writeln('cumulative normal distribution xphi(|x|)=');
xdisplay(e2);
writeln;
e4.c[1]:=0; e4.c[2]:=5; e4.n:=2; e4.i:=1; e4.d:=1; e4.s:=1;
if xgte(e2,e4) then
writeln('asymptotic value, can''t calculate the inverse function')
else begin
xiphi(e2,e4);
xapp(e4,e4,prec_out);
writeln('inverse xiphi of the cumulative normal distribution');
xdisplay(e4);
if xeq(e4,eb) then begin
writeln;
writeln('ok')
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
xlnor(e1,e2);
writeln('lower tail cumulative probability xlnor(x)=');
xdisplay(e2);
writeln;
if ((e2.c[1]=0) or (e2.c[1]=1)) and (e2.n=1) then
writeln('asymptotic value, can''t calculate the inverse function')
else begin
xilnor(e2,e4);
xapp(e4,e4,prec_out);
writeln('inverse xilnor of the lower tail cumulative probability');
xdisplay(e4);
if xeq(e4,e1) then begin
writeln;
writeln('ok')
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
xunor(e1,e2);
writeln('upper tail cumulative probability xunor(x)=');
xdisplay(e2);
writeln;
if ((e2.c[1]=0) or (e2.c[1]=1)) and (e2.n=1) then
writeln('asymptotic value, can''t calculate the inverse function')
else begin
xiunor(e2,e4);
xapp(e4,e4,prec_out);
writeln('inverse xiunor of the upper tail cumulative probability');
xdisplay(e4);
if xeq(e4,e1) then begin
writeln;
writeln('ok')
end
end;
usrdigits:=prec_ex
END;

PROCEDURE tri_proc;
BEGIN
clrscr;
xabs(e1,eb);
write('x=');
xdisplay(e1);
writeln;
sin_red(e1,en);
writeln('reduced angle for the sine');
xapp(en,en,prec_out);
xdisplay(en);
writeln;
xsin(e1,e3);
writeln('sin(x)=');
xapp(e3,e4,prec);
xdisplay(e4);
writeln;
xasin(e3,e5);
xapp(e5,e6,prec_out);
writeln('arcsine of the sine');
xdisplay(e6);
if xeq(e6,en) then begin
writeln;
writeln('ok')
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
cos_red(e1,en);
writeln('reduced angle for the cosine');
xapp(en,en,prec_out);
xdisplay(en);
writeln;
xcos(e1,e3);
writeln('cos(x)=');
xapp(e3,e4,prec);
xdisplay(e4);
writeln;
xacos(e3,e5);
xapp(e5,e6,prec_out);
writeln('arccosine of the cosine');
xdisplay(e6);
if xeq(e6,en) then begin
writeln;
writeln('ok')
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
tan_red(e1,en);
writeln('reduced angle for the tangent');
xapp(en,en,prec_out);
xdisplay(en);
writeln;
xtan(e1,e3);
if xstatus=11 then writeln('overflow in tangent')
else begin
xapp(e3,e4,prec);
if xstatus=26 then writeln('overflow in tangent')
else begin
writeln('tan(x)=');
xdisplay(e4);
writeln;
xatan(e3,e5);
xapp(e5,e6,prec_out);
writeln('arctangent of the tangent');
xdisplay(e6);
if xeq(e6,en) then begin
writeln;
writeln('ok')
end
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
cot_red(e1,en);
writeln('reduced angle for the cotangent');
xapp(en,en,prec_out);
xdisplay(en);
writeln;
xcot(e1,e3);
if xstatus=12 then writeln('overflow in cotangent')
else begin
xapp(e3,e4,prec);
if xstatus=26 then writeln('overflow in cotangent')
else begin
writeln('cot(x)=');
xdisplay(e4);
writeln;
xacot(e3,e5);
xapp(e5,e6,prec_out);
writeln('arccotangent of the cotangent');
xdisplay(e6);
if xeq(e6,en) then begin
writeln;
writeln('ok')
end
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
sec_red(e1,en);
writeln('reduced angle for the secant');
xapp(en,en,prec_out);
xdisplay(en);
writeln;
xsec(e1,e3);
if xstatus=13 then writeln('overflow in secant')
else begin
xapp(e3,e4,prec);
if xstatus=26 then writeln('overflow in secant')
else begin
writeln('sec(x)=');
xdisplay(e4);
writeln;
xasec(e3,e5);
xapp(e5,e6,prec_out);
writeln('arcsecant of the secant');
xdisplay(e6);
if xeq(e6,en) then begin
writeln;
writeln('ok')
end
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
csc_red(e1,en);
writeln('reduced angle for the cosecant');
xapp(en,en,prec_out);
xdisplay(en);
writeln;
xcsc(e1,e3);
if xstatus=14 then writeln('overflow in cosecant')
else begin
xapp(e3,e4,prec);
if xstatus=26 then writeln('overflow in cosecant')
else begin
writeln('csc(x)=');
xdisplay(e4);
writeln;
xacsc(e3,e5);
xapp(e5,e6,prec_out);
writeln('arccosecant of the cosecant');
xdisplay(e6);
if xeq(e6,en) then begin
writeln;
writeln('ok')
end
end
end
END;

PROCEDURE hyp_proc;
BEGIN
clrscr;
xabs(e1,eb);
xtostr(eb,sb);
if sb[1]='+' then delete(sb,1,1);
write('x=');
xdisplay(e1);
writeln;
xsinh(e1,e2);
if xstatus=27 then writeln('overflow in hyperbolic sine')
else begin
writeln('sinh(x)=');
xapp(e2,e3,prec);
xdisplay(e3);
writeln;
xasinh(e2,e3);
xapp(e3,e5,prec_out);
writeln('inverse hyperbolic sine');
xdisplay(e5);
if xeq(e5,e1) then begin
writeln;
writeln('ok')
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('|x|=');
writeln(sb);
writeln;
xcosh(e1,e2);
gotoxy(1,3);
if xstatus=28 then writeln('overflow in hyperbolic cosine')
else begin
writeln('cosh(|x|)=');
xapp(e2,e3,prec);
xdisplay(e3);
writeln;
xacosh(e2,e3);
xapp(e3,e5,prec_out);
writeln('inverse hyperbolic cosine');
xdisplay(e5);
if xeq(e5,eb) then begin
writeln;
writeln('ok')
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
xtanh(e1,e2);
writeln('tanh(x)=');
xapp(e2,e3,prec);
xdisplay(e3);
writeln;
if (e3.c[1]<>1) or (e3.n<>1) then begin
xatanh(e2,e3);
if xstatus=29 then writeln('wrong argument in inverse hyperbolic tangent')
else begin
xapp(e3,e5,prec_out);
writeln('inverse hyperbolic tangent');
xdisplay(e5);
if xeq(e5,e1) then begin
writeln;
writeln('ok')
end
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
if (e1.c[1]=0) and (e1.n=1) then
writeln('wrong argument for hyperbolic cotangent')
else begin
xcoth(e1,e2);
xapp(e2,e3,prec);
if xstatus=26 then writeln('overflow in hyperbolic cotangent')
else begin
writeln('coth(x)=');
xdisplay(e3);
writeln;
if (e3.c[1]<>1) or (e3.n<>1) then begin
monetox(e4);
onetox(e5);
if xlt(e2,e4) or xgt(e2,e5) then begin
xacoth(e2,e3);
xapp(e3,e5,prec_out);
writeln('inverse hyperbolic cotangent');
xdisplay(e5);
if xeq(e5,e1) then begin
writeln;
writeln('ok')
end
end
end
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('|x|=');
writeln(sb);
gotoxy(1,3);
xsech(e1,e2);
xapp(e2,e3,prec);
if xstatus=26 then writeln('overflow in hyperbolic secant')
else begin
writeln('sech(|x|)=');
xdisplay(e3);
writeln;
if (e3.c[1]<>0) or (e3.n<>1) then begin
xasech(e2,e3);
xapp(e3,e5,prec_out);
if xstatus=26 then writeln('overflow in inverse hyperbolic secant')
else begin
writeln('inverse hyperbolic secant');
xdisplay(e5);
if xeq(e5,eb) then begin
writeln;
writeln('ok')
end
end
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('x=');
xdisplay(e1);
writeln;
if (e1.c[1]=0) and (e1.n=1) then
writeln('wrong argument for hyperbolic cosecant')
else begin
xcsch(e1,e2);
xapp(e2,e3,prec);
if xstatus=26 then writeln('overflow in hyperbolic cosecant')
else begin
writeln('csch(x)=');
xdisplay(e3);
writeln;
if (e3.c[1]<>0) or (e3.n<>1) then begin
xacsch(e2,e3);
xapp(e3,e5,prec_out);
if xstatus=26 then writeln('overflow in inverse hyperbolic cosecant')
else begin
writeln('inverse hyperbolic cosecant');
xdisplay(e5);
if xeq(e5,e1) then begin
writeln;
writeln('ok')
end
end
end
end
end
END;

PROCEDURE oth_proc;
BEGIN
clrscr;
xabs(e1,eb);
xtostr(eb,sb);
if sb[1]='+' then delete(sb,1,1);
write('x=');
xdisplay(e1);
xtoe(e1,ex);
if xstatus=2 then writeln('no conversion to extended, number too big')
else begin
writeln('conversion from extnum to extended: ',ex);
etox(ex,e2);
if xstatus=1 then writeln('no conversion from extended to extnum, number too big')
else begin
writeln('conversion from extended to extnum:');
xdisplay(e2)
end
end;
writeln;
writeln('fractional part');
xfrac(e1,e2);
xdisplay(e2);
writeln;
xint(e1,e3);
writeln('integer part');
xdisplay(e3);
writeln;
xceil(e1,e2);
writeln('ceil function');
xdisplay(e2);
writeln;
xfloor(e1,e2);
writeln('floor function');
xdisplay(e2);
xabs(e1,eb);
writeln;
writeln('absolute value');
xdisplay(eb);
getkey;
if t='Q' then exit;
clrscr;
write('|x|=');
writeln(sb);
gotoxy(1,3);
writeln('square root of the absolute value');
xtox(e1,e2);
e2.s:=1;
xsqrt(e2,e3);
xapp(e3,e4,prec);
xdisplay(e4);
writeln;
xmul(e3,e3,e5);
xapp(e5,e6,prec_out);
writeln('square of the square root');
xdisplay(e6);
if xeq(eb,e6) then begin
writeln;
writeln('ok')
end;
getkey;
if t='Q' then exit;
clrscr;
write('|x|=');
writeln(sb);
gotoxy(1,3);
if (e1.c[1]=0) and (e1.n=1) then begin
writeln('wrong argument in logarithm');
writeln;
xexp(e1,e2);
if xstatus=19 then writeln('overflow in exponential')
else begin
xapp(e2,e3,prec);
if xstatus=26 then writeln('overflow in exponential')
else begin
writeln('exp(x)');
xdisplay(e3)
end
end
end
else begin
xtox(e1,e2);
e2.s:=1;
writeln('ln(|x|)=');
xln(e2,e3);
xapp(e3,e4,prec);
xdisplay(e4);
writeln;
xexp(e3,e5);
xapp(e5,e6,prec_out);
writeln('exponential of the logarithm');
xdisplay(e6);
if xeq(eb,e6) then begin
writeln;
writeln('ok')
end
end;
getkey;
if t='Q' then exit;
clrscr;
write('|x|=');
writeln(sb);
gotoxy(1,3);
if (e1.c[1]=0) and (e1.n=1) then
writeln('wrong argument in logarithm')
else begin
writeln('log(|x|)=');
xlog(e2,e3);
xapp(e3,e4,prec);
xdisplay(e4);
writeln;
wtox(10,e5);
xpow(e5,e3,e4);
xapp(e4,e5,prec_out);
writeln('power of 10 with the logarithm as exponent');
xdisplay(e5);
if xeq(e5,eb) then begin
writeln;
writeln('ok')
end
end
END;

PROCEDURE test_a;
BEGIN
xsetn(200); {digits over the precision}
prec:=77;   {required precision}
pitox(p);
twotox(eq);
xdiv(p,eq,p1);
xmul(p,eq,p2);
xadd(p,p1,p3);
repeat
clrscr;
writeln('Precision: 77 digits, working with usrdigits=200');
writeln('Please enter a real number (<CR> to quit)');
write(': ');
s:=inpstnum(76);
if s='' then break;
strtox(s,e1,w);
xelz(e1);
clrscr;
write('x=');
xdisplay(e1);
xtoe(e1,ex);
if xstatus=2 then writeln('no conversion to extended, integer part too big')
else writeln('conversion from extnum to extended: ',ex);
xfrac(e1,e2);
writeln('fractional part');
xdisplay(e2);
xint(e1,e3);
writeln('integer part');
xdisplay(e3);
xceil(e1,e2);
writeln('ceil function');
xdisplay(e2);
xfloor(e1,e2);
writeln('floor function');
xdisplay(e2);
xabs(e1,eb);
xtostr(eb,sb);
if sb[1]='+' then delete(sb,1,1);
writeln('absolute value');
xdisplay(eb);
xtox(e1,e2);
e2.s:=1;
xsqrt(e2,e3);
xapp(e3,e4,prec);
writeln('square root of the absolute value');
xdisplay(e4);
xmul(e3,e3,e5);
writeln('square of the square root');
xapp(e5,e5,prec);
xdisplay(e5);
if (e1.c[1]=0) and (e1.n=1) then begin
writeln('wrong argument for logarithm');
xexp(e1,e2);
if xstatus=19 then writeln('overflow in exponential')
else begin
xapp(e2,e3,prec);
writeln('exponential');
xdisplay(e3)
end
end
else begin
xtox(e1,e2);
if e2.s=0 then e2.s:=1;
writeln('natural logarithm of the absolute value');
xln(e2,e3);
xapp(e3,e4,prec);
xdisplay(e4);
xexp(e3,e5);
xapp(e5,e5,prec);
writeln('exponential of the logarithm');
xdisplay(e5);
writeln('base 10 logarithm of the absolute value');
xlog(e2,e3);
xapp(e3,e4,prec);
xdisplay(e4);
wtox(10,e5);
xpow(e5,e3,e4);
xapp(e4,e4,prec);
writeln('power of 10 with the logarithm as exponent');
xdisplay(e4)
end;
getkey;
if t='Q' then continue;
clrscr;
write('x=');
xdisplay(e1);
writeln;
sin_red(e1,en);
writeln('reduced angle for the sine');
xapp(en,en,prec);
xdisplay(en);
xsin(e1,e3);
writeln('sin(x)=');
xapp(e3,e4,prec);
xdisplay(e4);
xasin(e3,e5);
xapp(e5,e5,prec);
writeln('arcsine of the sine');
xdisplay(e5);
if xeq(e5,en) then writeln('ok');
cos_red(e1,en);
writeln('reduced angle for the cosine');
xapp(en,en,prec);
xdisplay(en);
xcos(e1,e4);
writeln('cos(x)=');
xapp(e4,e5,prec);
xdisplay(e5);
xacos(e4,e5);
xapp(e5,e5,prec);
writeln('arccosine of the cosine');
xdisplay(e5);
if xeq(e5,en) then writeln('ok');
tan_red(e1,en);
writeln('reduced angle for the tangent');
xapp(en,en,prec);
xdisplay(en);
xtan(e1,e3);
if xstatus=11 then writeln('overflow in tangent')
else begin
writeln('tan(x)=');
xapp(e3,e4,prec);
xdisplay(e4);
xatan(e3,e5);
xapp(e5,e5,prec);
writeln('arctangent of the tangent');
xdisplay(e5);
if xeq(e5,en) then writeln('ok')
end;
getkey;
if t='Q' then continue;
clrscr;
write('x=');
xdisplay(e1);
writeln;
cot_red(e1,en);
writeln('reduced angle for the cotangent');
xapp(en,en,prec);
xdisplay(en);
xcot(e1,e3);
if xstatus=12 then writeln('overflow in cotangent')
else begin
writeln('cot(x)=');
xapp(e3,e4,prec);
xdisplay(e4);
xacot(e3,e5);
xapp(e5,e5,prec);
writeln('arccotangent of the cotangent');
xdisplay(e5);
if xeq(e5,en) then writeln('ok')
end;
sec_red(e1,en);
writeln('reduced angle for the secant');
xapp(en,en,prec);
xdisplay(en);
xsec(e1,e3);
if xstatus=13 then writeln('overflow in secant')
else begin
writeln('sec(x)=');
xapp(e3,e4,prec);
xdisplay(e4);
xasec(e3,e5);
xapp(e5,e5,prec);
writeln('arcsecant of the secant');
xdisplay(e5);
if xeq(e5,en) then writeln('ok')
end;
csc_red(e1,en);
writeln('reduced angle for the cosecant');
xapp(en,en,prec);
xdisplay(en);
xcsc(e1,e3);
if xstatus=14 then writeln('overflow in cosecant')
else begin
writeln('csc(x)=');
xapp(e3,e4,prec);
xdisplay(e4);
xacsc(e3,e5);
xapp(e5,e5,prec);
writeln('arccosecant of the cosecant');
xdisplay(e5);
if xeq(e5,en) then writeln('ok')
end;
getkey;
if t='Q' then continue;
clrscr;
xsinh(e1,e2);
if xstatus=27 then writeln('overflow in hyperbolic sine')
else begin
xapp(e2,e3,prec);
if xstatus=26 then writeln('overflow in hyperbolic sine')
else begin
writeln('sinh(x)=');
xdisplay(e3);
xasinh(e2,e3);
xapp(e3,e4,prec);
writeln('inverse hyperbolic sine');
xdisplay(e4)
end
end;

xcosh(e1,e2);
if xstatus=28 then writeln('overflow in hyperbolic cosine')
else begin
xapp(e2,e3,prec);
if xstatus=26 then writeln('overflow in hyperbolic cosine')
else begin
writeln('cosh(x)=');
xdisplay(e3);
xacosh(e2,e3);
xapp(e3,e4,prec);
writeln('inverse hyperbolic cosine');
xdisplay(e4)
end
end;
xtanh(e1,e2);
xapp(e2,e3,prec);
writeln('tanh(x)=');
xdisplay(e3);
if (e3.c[1]<>1) or (e3.n<>1) then begin
xatanh(e2,e3);
if xstatus=32 then writeln('wrong argument in inverse hyperbolic tangent')
else begin
xapp(e3,e3,prec);
writeln('inverse hyperbolic tangent');
xdisplay(e3)
end
end;
if (e1.c[1]=0) and (e1.n=1) then
writeln('wrong argument for hyperbolic cotangent')
else begin
xcoth(e1,e2);
xapp(e2,e3,prec);
if xstatus=26 then writeln('overflow in hyperbolic cotangent')
else begin
writeln('coth(x)=');
xdisplay(e3);
if (e3.c[1]<>1) or (e3.n<>1) then begin
monetox(e4);
onetox(e5);
if xlt(e2,e4) or xgt(e2,e5) then begin
xacoth(e2,e3);
xapp(e3,e3,prec);
writeln('inverse hyperbolic cotangent');
xdisplay(e3)
end
end
end
end;
xsech(e1,e2);
xapp(e2,e3,prec);
writeln('sech(x)=');
xdisplay(e3);
if (e3.c[1]<>0) or (e3.n<>1) then begin
xasech(e2,e3);
xapp(e3,e3,prec);
if xstatus=26 then writeln('overflow in inverse hyperbolic secant')
else begin
writeln('inverse hyperbolic secant');
xdisplay(e3)
end
end;
if (e1.c[1]=0) and (e1.n=1) then
writeln('wrong argument for hyperbolic cosecant')
else begin
xcsch(e1,e2);
xapp(e2,e3,prec);
if xstatus=26 then writeln('overflow in hyperbolic cosecant')
else begin
writeln('csch(x)=');
xdisplay(e3);
if (e3.c[1]<>0) or (e3.n<>1) then begin
xacsch(e2,e3);
xapp(e3,e3,prec);
if xstatus=26 then writeln('overflow in inverse hyperbolic cosecant')
else begin
writeln('inverse hyperbolic cosecant');
xdisplay(e3)
end
end
end
end;
getkey;
if t='Q' then continue;
clrscr;
write('x=');
xdisplay(e1);
writeln;
xerf(e1,e2);
xapp(e2,e3,prec);
writeln('error function xerf');
xdisplay(e3);
if (e3.c[1]=1) and (e3.n=1) then
writeln('asymptotic value, the inverse error function can''t be calculated')
else begin
xerfinv(e2,e4);
xapp(e4,e4,prec);
writeln('inverse error function xerfinv');
xdisplay(e4)
end;
xerfc(e1,e2);
if xstatus=41 then
writeln('the argument of the complementary error function is out of range')
else begin
xapp(e2,e3,prec);
writeln('complementary error function xerfc');
xdisplay(e3);
if ((e3.c[1]=0) or (e3.c[1]=2)) and (e3.n=1) then
writeln('asymptotic value, the inverse function can''t be calculated')
else begin
xerfcinv(e2,e3);
xapp(e3,e4,prec);
writeln('inverse complementary error function xerfcinv');
xdisplay(e4)
end
end;
xphi(eb,e2);
if xstatus=42 then
writeln('the argument of the cumulative distribution function is out of range')
else begin
xapp(e2,e3,prec);
writeln('cumulative normal distribution xphi of the absolute value');
xdisplay(e3);
e4.c[1]:=0; e4.c[2]:=5; e4.n:=2; e4.i:=1; e4.d:=1; e4.s:=1;
if xgte(e3,e4) then
writeln('asymptotic value, the inverse function can''t be calculated')
else begin
xiphi(e2,e4);
xapp(e4,e4,prec);
writeln('inverse cumulative normal distribution xiphi');
xdisplay(e4)
end
end;
xlnor(e1,e2);
xapp(e2,e3,prec);
writeln('lower tail cumulative probability xlnor of the standard normal distribution');
xdisplay(e3);
if ((e3.c[1]=1) or (e3.c[1]=0)) and (e3.n=1) then
writeln('asymptotic value, the inverse function can''t be calculated')
else begin
xilnor(e2,e3);
xapp(e3,e4,prec);
writeln('inverse lower tail cumulative probability xilnor');
xdisplay(e4)
end;
xunor(e1,e2);
xapp(e2,e3,prec);
writeln('upper tail cumulative probability xunor of the standard normal distribution');
xdisplay(e3);
if ((e3.c[1]=1) or (e3.c[1]=0)) and (e3.n=1) then
writeln('asymptotic value, the inverse function can''t be calculated')
else begin
xiunor(e2,e3);
xapp(e3,e4,prec);
writeln('inverse upper tail cumulative probability xiunor');
xdisplay(e4)
end;
gotoxy(1,25);
write('End of this 77 digit test. Press a key... ');
t:=upcase(readkey);
until false
END;

PROCEDURE ari_proc;
BEGIN
clrscr;
write('a=');
xdisplay(a1);
write('b=');
xdisplay(a2);
writeln;
xadd(a1,a2,a3);
writeln('r=a+b');
write('r=');
xdisplay(a3);
xsub(a3,a2,a4);
writeln;
writeln('a=r-b');
write('a=');
xdisplay(a4);
if xeq(a4,a1) then writeln('ok');
writeln;
xsub(a1,a2,a3);
writeln('r=a-b');
write('r=');
xdisplay(a3);
xadd(a3,a2,a4);
writeln;
writeln('a=r+b');
write('a=');
xdisplay(a4);
if xeq(a4,a1) then writeln('ok');
getkey;
if t='Q' then exit;
clrscr;
write('a=');
xdisplay(a1);
write('b=');
xdisplay(a2);
writeln;
xmul(a1,a2,a3);
writeln('r=a*b');
write('r=');
xdisplay(a3);
xdiv(a3,a2,a4);
writeln;
writeln('a=r/b');
write('a=');
xdisplay(a4);
if xeq(a4,a1) then writeln('ok');
writeln;
xtox(a1,a3);
xmul2s(a3);
writeln('r=a*2');
write('r=');
xdisplay(a3);
writeln;
xdiv2s(a3);
writeln('a=r/2');
write('a=');
xdisplay(a3);
if xeq(a1,a3) then writeln('ok');
getkey;
if t='Q' then exit;
clrscr;
write('a=');
xdisplay(a1);
write('b=');
xdisplay(a2);
writeln;
xdiv(a1,a2,a3);
if xstatus=8 then writeln('overflow in division')
else if xstatus=9 then writeln('impossible to divide by 0, undefined result')
else begin
writeln('r=a/b');
write('r=');
xapp(a3,a4,prec);
xdisplay(a4);
xmul(a3,a2,a4);
xapp(a4,a5,75);
writeln;
writeln('a=r*b');
write('a=');
xdisplay(a5);
if xeq(a5,a1) then begin
writeln;
writeln('ok')
end
end
END;

PROCEDURE test_b;
label menu;
BEGIN
xsetn(2100); {digits over the precision}
prec:=1000;  {required precision}
prec_out:=77;
pitox(p);
twotox(eq);
xdiv(p,eq,p1);
xmul(p,eq,p2);
xadd(p,p1,p3);
repeat
menu:
clrscr;
writeln('Precision: 1000 digits, working with usrdigits=2100');
writeln;
writeln('Please select:');
writeln;
writeln('A arithmetic operations');
writeln('T trigonometric functions');
writeln('H hyperbolic functions');
writeln('O other elementary functions');
writeln('S special functions');
writeln('Q quit');
writeln;
repeat
u:=upcase(readkey);
case u of
'Q': exit;
'A': begin
writeln('Arithmetic operations');
break
end;
'T': begin
writeln('Trigonometric functions');
break
end;
'H': begin
writeln('Hyperbolic functions');
break
end;
'O': begin
writeln('Other elementary functions');
break
end;
'S': begin
writeln('Special functions');
break
end
end;
until false;
if u='A' then begin
writeln('Please enter two operands');
write('a: ');
repeat
s:=inpstnum(75);
if s='' then goto menu;
strtox(s,a1,w);
until w=0;
xelz(a1);
write('b: ');
repeat
s:=inpstnum(75);
if s='' then goto menu;
strtox(s,a2,w);
until w=0;
xelz(a2)
end
else begin
writeln('Please enter a real number (<CR> to quit)');
write(': ');
repeat
s:=inpstnum(76);
if s='' then goto menu;
strtox(s,e1,w);
until w=0;
xelz(e1)
end;
writeln;
if u='A' then ari_proc
else if u='T' then tri_proc
else if u='H' then hyp_proc
else if u='S' then spc_proc
else if u='O' then oth_proc;
gotoxy(1,25);
write('End of this 1000 digit test. Press a key... ');
t:=upcase(readkey);
until false
END;

BEGIN
prec_spc:=1000;
repeat
clrscr;
writeln('Please select a precision: [A] 77 digits - [B] 1000 digits, or [Q] to quit ');
write(': ');
t:=upcase(readkey);
writeln;
if t='A' then test_a
else if t='B' then test_b
else if t='Q' then break;
until false
END.
